//! # very short description
//!
//! Short description
//!
//! Details
//!
//! ## Section 1
//!
//! ## Section 2

//// ATTRIBUTES ////////////////////////////////////////////////////////////////////////////////////
// we want docs
#![warn(missing_docs)]
#![warn(rustdoc::missing_crate_level_docs)]
// we want Debug everywhere.
#![warn(missing_debug_implementations)]
// enable clippy's extra lints, the pedantic version
#![warn(clippy::pedantic)]

//// IMPORTS ///////////////////////////////////////////////////////////////////////////////////////
use ockam::{Context, Result, Routed, Worker};

use crate::packet::NabiPacket;

//// TYPES /////////////////////////////////////////////////////////////////////////////////////////

//// CONSTANTS /////////////////////////////////////////////////////////////////////////////////////

//// STATICS ///////////////////////////////////////////////////////////////////////////////////////

//// MACROS ////////////////////////////////////////////////////////////////////////////////////////

//// ENUMS /////////////////////////////////////////////////////////////////////////////////////////

//// STRUCTS ///////////////////////////////////////////////////////////////////////////////////////
pub struct Receiver;

//// IMPLEMENTATION ////////////////////////////////////////////////////////////////////////////////
#[ockam::worker]
impl Worker for Receiver {
    type Context = Context;
    type Message = NabiPacket;
    async fn handle_message(&mut self, ctx: &mut Context, msg: Routed<NabiPacket>) -> Result<()> {
        println!("Address: {}, Received: {}", ctx.address(), msg);
        // Echo the message body back on its return_route.
        ctx.send(msg.return_route(), msg.body()).await
    }
}

//// PUBLIC FUNCTIONS //////////////////////////////////////////////////////////////////////////////

//// PRIVATE FUNCTIONS /////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////
